## opennebula-7.1.80-1-amd64.tar.gz

=== SConstruct ===
# -*- coding: utf-8 -*-
# -------------------------------------------------------------------------- #
# Copyright 2002-2025, OpenNebula Project, OpenNebula Systems                #
#                                                                            #
# Licensed under the Apache License, Version 2.0 (the "License"); you may    #
# not use this file except in compliance with the License. You may obtain    #
# a copy of the License at                                                   #
#                                                                            #
# http://www.apache.org/licenses/LICENSE-2.0                                 #
#                                                                            #
# Unless required by applicable law or agreed to in writing, software        #
# distributed under the License is distributed on an "AS IS" BASIS,          #
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   #
# See the License for the specific language governing permissions and        #
# limitations under the License.                                             #
# -------------------------------------------------------------------------- #

import os
import sys
import shutil
from subprocess import Popen, PIPE

import SCons
from SCons.Environment import Environment
from SCons.Script import ARGUMENTS, SConscript

sys.path.append("./share/scons")
from lex_bison import *

# Get git version
try:
    out = Popen(["git", "describe", "--dirty", "--always", "--abbrev=8"],
                stdout=PIPE)
    git_version = out.communicate()[0].rstrip().decode('utf-8')
except OSError:
    git_version = ARGUMENTS.get('gitversion', 'not known')

# This is the absolute path where the project is located
cwd = os.getcwd()

# Environment that will be applied to each scons child
main_env = Environment()
main_env['ENV']['PATH'] = os.environ['PATH']

main_env['CXXFLAGS'] = " -DGITVERSION=\'\"" + git_version + "\"\'"

# snippet borrowed from http://dev.gentoo.org/~vapier/scons-blows.txt
# makes scons aware of build related environment variables
if 'CC' in os.environ:
    main_env['CC'] = os.environ['CC']
if 'CFLAGS' in os.environ:
    main_env['CCFLAGS'] += SCons.Util.CLVar(os.environ['CFLAGS'])
if 'CXX' in os.environ:
    main_env['CXX'] = os.environ['CXX']
if 'CXXFLAGS' in os.environ:
    main_env['CXXFLAGS'] += SCons.Util.CLVar(os.environ['CXXFLAGS'])
if 'LDFLAGS' in os.environ:
    main_env['LINKFLAGS'] += SCons.Util.CLVar(os.environ['LDFLAGS'])
else:
    os.environ['LDFLAGS'] = ""

# Add builders for flex and bison
add_lex(main_env)
add_bison(main_env)

# Include dirs
main_env.Append(CPPPATH=[
    cwd+'/include',
    cwd+'/src/rm/xml-rpc',
    cwd+'/src/rm/api',
    cwd+'/src/monitor/include',
    cwd+'/src/parsers'
])

# Library dirs
main_env.Append(LIBPATH=[
    cwd+'/src/parsers',
    cwd+'/src/common',
    cwd+'/src/log',
    cwd+'/src/raft',
    cwd+'/src/sql',
    cwd+'/src/host',
    cwd+'/src/cluster',
    cwd+'/src/datastore',
    cwd+'/src/group',
    cwd+'/src/nebula',
    cwd+'/src/pool',
    cwd+'/src/template',
    cwd+'/src/vm',
    cwd+'/src/vm_group',
    cwd+'/src/vm_template',
    cwd+'/src/vmm',
    cwd+'/src/lcm',
    cwd+'/src/tm',
    cwd+'/src/dm',
    cwd+'/src/im',
    cwd+'/src/image',
    cwd+'/src/rm',
    cwd+'/src/vnm',
    cwd+'/src/vn_template',
    cwd+'/src/hm',
    cwd+'/src/um',
    cwd+'/src/authm',
    cwd+'/src/acl',
    cwd+'/src/xml',
    cwd+'/src/document',
    cwd+'/src/zone',
    cwd+'/src/client',
    cwd+'/src/secgroup',
    cwd+'/src/vdc',
    cwd+'/src/vrouter',
    cwd+'/src/market',
    cwd+'/src/ipamm',
    cwd+'/src/data_model',
    cwd+'/src/protocol',
    cwd+'/src/sam',
    cwd+'/src/schedm'
])

# Compile flags
main_env.Append(CPPFLAGS=[
    "-g",
    "-Wall",
    "-std=c++17",
    "-Wno-overloaded-virtual"
])

# Linking flags & common libraries
main_env.Append(LINKFLAGS=['-g', '-pthread'])
main_env.Append(LIBS=['z'])

#######################
# EXTRA CONFIGURATION #
#######################

# Generate help text
vars = Variables('custom.py')
vars.Add('sqlite_dir', 'Path to sqlite directory', '')
vars.Add('sqlite', 'Build with SQLite support', 'yes')
vars.Add('mysql', 'Build with MySQL support', 'no')
vars.Add('parsers', 'Rebuild flex/bison files', 'no')
vars.Add('fireedge', 'Build FireEdge', 'no')
vars.Add('systemd', 'Build with systemd support', 'no')
vars.Add('rubygems', 'Generate Ruby gems', 'no')
vars.Add('svncterm', 'Build VNC support for LXD drivers', 'yes')
vars.Add('context', 'Download guest contextualization packages', 'no')
vars.Add('strict', 'Strict C++ compiler, more warnings, treat warnings as errors', 'no')
vars.Add('download', 'Download 3rdParty tools', 'no')
vars.Add('xmlrpc_pkgconf', 'Use pkg-config for xmlrpc-c libs dependency', 'no')
env = Environment(variables = vars)
Help(vars.GenerateHelpText(env))

# SQLITE
sqlite_dir = ARGUMENTS.get('sqlite_dir', "none")
if sqlite_dir != 'none':
    main_env.Append(LIBPATH=[sqlite_dir+"/lib", sqlite_dir+"/lib64"])
    main_env.Append(CPPPATH=[sqlite_dir+"/include"])

sqlite = ARGUMENTS.get('sqlite', 'yes')
if sqlite == 'yes':
    main_env.Append(sqlite='yes')
    main_env.Append(CPPFLAGS=["-DSQLITE_DB"])
    main_env.Append(LIBS=['sqlite3'])
else:
    main_env.Append(sqlite='no')

# MySQL
mysql = ARGUMENTS.get('mysql', 'no')
if mysql == 'yes':
    main_env.Append(mysql='yes')
    main_env.Append(CPPFLAGS=["-DMYSQL_DB"])
    main_env.Append(LIBS=['mysqlclient'])
else:
    main_env.Append(mysql='no')

# grpc
grpc = ARGUMENTS.get('grpc', 'yes')

if grpc == 'yes':
    main_env.Append(grpc='yes')

    main_env.Append(CPPFLAGS=["-DGRPC", "-DGRPC_CALLBACK_API_NONEXPERIMENTAL"])

    main_env.Append(CPPPATH=[
        cwd+'/src/rm/grpc',
        cwd+'/src/rm/grpc/src',
    ])

    main_env.ParseConfig('pkg-config --cflags --libs grpc++ protobuf')

    main_env.Append(LIBS=['grpc++_reflection'])
else:
    main_env.Append(grpc='no')

# grpc
grpcproto = ARGUMENTS.get('grpcproto', 'no')

if grpcproto == 'yes':
    main_env.Append(proto='yes')
else:
    main_env.Append(proto='no')

# systemd
systemd = ARGUMENTS.get('systemd', 'no')
if systemd == 'yes':
    main_env.Append(systemd='yes')
    main_env.Append(CPPFLAGS=["-DSYSTEMD"])
    main_env.Append(LIBS=['systemd'])
else:
    main_env.Append(systemd='no')

# build lex/bison
build_parsers = ARGUMENTS.get('parsers', 'no')
if build_parsers == 'yes':
    main_env.Append(parsers='yes')
else:
    main_env.Append(parsers='no')

# strict: Add more warnings add treat warnings as errors
strict = ARGUMENTS.get('strict', 'no')
if strict == 'yes':
    main_env.Append(CPPFLAGS=[
        "-Wextra",
        "-Werror",
        "-Wno-error=deprecated-declarations",
        "-Wno-unused-parameter",
        "-Wno-unused-result"
    ])

# Download: Download 3rdParty tools
download = ARGUMENTS.get('download', 'no')
if download == 'yes':
    tools = Popen(['find', '.', '-type', 'f', '-executable', '-path', '*/vendor/download'], stdout=PIPE).stdout.readlines()

    for t in tools:
        tool = t.rstrip().decode()
        print("Executing: {}".format(tool))
        Popen(tool)

# Rubygem generation
main_env.Append(rubygems=ARGUMENTS.get('rubygems', 'no'))

# Enterprise Edition
main_env.Append(enterprise=ARGUMENTS.get('enterprise', 'no'))

# FireEdge minified files generation
main_env.Append(fireedge=ARGUMENTS.get('fireedge', 'no'))

# Context packages download
main_env.Append(context=ARGUMENTS.get('context', 'no'))

# Use pkg-config to detect xmlrpc-c libs
main_env.Append(xmlrpc_pkgconf=ARGUMENTS.get('xmlrpc_pkgconf', 'no'))

if not main_env.GetOption('clean'):
    try:
        if mysql == 'yes':
            main_env.ParseConfig('mysql_config --cflags --libs')
    except Exception:
        print("")
        print("mysql_config was not found in the path")
        print("")
        print("Check that mysql development package is installed and")
        print("mysql_config is in the path. If your mysql config tool")
        print("is called mysql5_config make a symlink as mysql_config")
        print("to a directory in the path.")
        print("")
        exit(-1)

    xmlrpc_pkgconf = ARGUMENTS.get('xmlrpc_pkgconf', 'no')
    # xmlrpc-c-config doesn't work well in el8/9 use pkg-config directly
    if xmlrpc_pkgconf == 'yes':
        try:
            main_env.ParseConfig('pkg-config xmlrpc xmlrpc++ xmlrpc_util xmlrpc_util++ xmlrpc_client xmlrpc_client++ --libs --cflags')
            main_env.ParseConfig('pkg-config xmlrpc_abyss xmlrpc_server_abyss++ xmlrpc_server xmlrpc_server++ xmlrpc_util xmlrpc_util++ xmlrpc_server_pstream --libs --cflags')
        except Exception:
            print("")
            print("pkg-config failed")
            print("")
            exit(-1)
    else:
        try:
            main_env.ParseConfig('xmlrpc-c-config c++2 client --libs --cflags')
            main_env.ParseConfig('xmlrpc-c-config c++2 abyss-server --libs --cflags')

        except Exception:
            print("")
            print("xmlrpc-c-config was not found in the path")
            print("")
            exit(-1)
else:
    main_env.Replace(mysql='yes')

# libxml2
main_env.ParseConfig('xml2-config --libs --cflags')

svncterm_path = 'src/svncterm_server/SConstruct'

# SCONS scripts to build
build_scripts = [
    'src/parsers/SConstruct',
    'src/sql/SConstruct',
    'src/log/SConstruct',
    'src/raft/SConstruct',
    'src/common/SConstruct',
    'src/template/SConstruct',
    'src/host/SConstruct',
    'src/cluster/SConstruct',
    'src/datastore/SConstruct',
    'src/group/SConstruct',
    'src/nebula/SConstruct',
    'src/pool/SConstruct',
    'src/vm/SConstruct',
    'src/vm_group/SConstruct',
    'src/vm_template/SConstruct',
    'src/vmm/SConstruct',
    'src/lcm/SConstruct',
    'src/rm/SConstruct',
    'src/tm/SConstruct',
    'src/im/SConstruct',
    'src/image/SConstruct',
    'src/dm/SConstruct',
    'src/schedm_mad/remotes/rank/SConstruct',
    'src/vnm/SConstruct',
    'src/vn_template/SConstruct',
    'src/hm/SConstruct',
    'src/um/SConstruct',
    'src/authm/SConstruct',
    'src/acl/SConstruct',
    'src/xml/SConstruct',
    'src/document/SConstruct',
    'src/zone/SConstruct',
    'src/secgroup/SConstruct',
    'src/vdc/SConstruct',
    'src/vrouter/SConstruct',
    'src/market/SConstruct',
    'src/ipamm/SConstruct',
    'src/fireedge/SConstruct',
    'share/rubygems/SConstruct',
    'src/client/SConstruct',
    'src/monitor/SConstruct',
    'src/protocol/SConstruct',
    'src/sam/SConstruct',
    'src/schedm/SConstruct',
    svncterm_path,
    'share/context/SConstruct'
]

# disable svncterm
svncterm = ARGUMENTS.get('svncterm', 'yes')
if svncterm == 'no':
    build_scripts.remove(svncterm_path)
else:
    pass

for script in build_scripts:
    env = main_env.Clone()
    SConscript(script, exports='env')

=== src/svncterm_server/SConstruct ===
# ---------------------------------------------------------------------------- #
# Copyright 2002-2025, OpenNebula Project, OpenNebula Systems                  #
#                                                                              #
# Licensed under the Apache License, Version 2.0 (the "License"); you may      #
# not use this file except in compliance with the License. You may obtain      #
# a copy of the License at                                                     #
#                                                                              #
# http://www.apache.org/licenses/LICENSE-2.0                                   #
#                                                                              #
# Unless required by applicable law or agreed to in writing, software          #
# distributed under the License is distributed on an "AS IS" BASIS,            #
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.     #
# See the License for the specific language governing permissions and          #
# limitations under the License.                                               #
# ---------------------------------------------------------------------------- #

import os

env = Environment()

env['LIBS'] = ['-lz']
env['CFLAGS'] = ['-std=c99', '-Wall']

env.Program('genfont.c')

env = Environment()
env['LIBS'] = ['-lvncserver', '-lpthread', '-lz', '-ljpeg',
               '-lutil', '-lgnutls']

env['CFLAGS'] = ['-D_GNU_SOURCE', '-std=c99', '-Wall']

env.Program('svncterm_server.c')

=== share/one/one-deploy/requirements.txt ===
molecule
netaddr
pyone>=6.8.0
setuptools

=== lib/one/fireedge/node_modules/zeromq/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

include(FetchContent)

if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.24.0")
  cmake_policy(SET CMP0135 NEW)
endif()

# Add project_options from https://github.com/aminya/project_options
set(PROJECT_OPTIONS_VERSION "v0.41.0")
FetchContent_Declare(
  _project_options
  URL https://github.com/aminya/project_options/archive/refs/tags/${PROJECT_OPTIONS_VERSION}.zip
)
FetchContent_MakeAvailable(_project_options)
include(${_project_options_SOURCE_DIR}/Index.cmake)

# Detect ZeroMQ options from environment variables
macro(set_option_from_env OPTION_NAME)
  string(TOLOWER ${OPTION_NAME} OPTION_NAME_LOWER)

  if(DEFINED ENV{npm_config_${OPTION_NAME_LOWER}})
    if("$ENV{npm_config_${OPTION_NAME_LOWER}}" STREQUAL "true")
      set("${OPTION_NAME}"
        ON
        CACHE BOOL "npm_config_${OPTION_NAME_LOWER}" FORCE)
    elseif("$ENV{npm_config_${OPTION_NAME_LOWER}}" STREQUAL "false")
      set("${OPTION_NAME}"
        OFF
        CACHE BOOL "npm_config_${OPTION_NAME_LOWER}" FORCE)
    else()
      set("${OPTION_NAME}"
        "$ENV{npm_config_${OPTION_NAME_LOWER}}"
        CACHE STRING "npm_config_${OPTION_NAME_LOWER}" FORCE)
    endif()
  endif()

  if(${OPTION_NAME})
    string(REPLACE "zmq_" "" OPTION_NAME_LOWER "${OPTION_NAME_LOWER}")
    string(REPLACE "_" "-" OPTION_NAME_LOWER "${OPTION_NAME_LOWER}")
    list(APPEND VCPKG_MANIFEST_FEATURES ${OPTION_NAME_LOWER})
  endif()

  message(STATUS "${OPTION_NAME}: ${${OPTION_NAME}}")
endmacro()

option(ZMQ_DRAFT "Build and install draft APIs (e.g. `server-client`, `radio-dish`, `scatter-gather`)" ON)
set_option_from_env(ZMQ_DRAFT)

option(ZMQ_CURVE "Enable CURVE security" ON)
set_option_from_env(ZMQ_CURVE)

option(ZMQ_SODIUM "Using libsodium for CURVE security" ON)
set_option_from_env(ZMQ_SODIUM)

if(ZMQ_SODIUM AND APPLE)
  message(STATUS "building libsodium requires running `brew install autoconf automake libtool`")
endif()

option(ZMQ_WEBSOCKETS "Enable WebSocket transport" OFF)
set_option_from_env(ZMQ_WEBSOCKETS)

option(ZMQ_WEBSOCKETS_SECURE "Enable WebSocket transport with TSL (wss)" OFF)
set_option_from_env(ZMQ_WEBSOCKETS_SECURE)

option(ZMQ_NO_SYNC_RESOLVE "send/receive on the socket immediately" OFF)
set_option_from_env(ZMQ_NO_SYNC_RESOLVE)

# Add undefined behavior sanitizer if requested
option(ZMQ_ENABLE_SANITIZER_UNDEFINED "Enable undefined behavior sanitizer" OFF)
set_option_from_env(ZMQ_ENABLE_SANITIZER_UNDEFINED)

if(${ZMQ_ENABLE_SANITIZER_UNDEFINED})
  set(ENABLE_SANITIZER_UNDEFINED "ENABLE_SANITIZER_UNDEFINED")
endif()

# Set MacOS deployment target
if(APPLE)
  option(MACOSX_DEPLOYMENT_TARGET "MacOS deployment target" "10.15")
  set_option_from_env(MACOSX_DEPLOYMENT_TARGET)
  set(CMAKE_OSX_DEPLOYMENT_TARGET ${MACOSX_DEPLOYMENT_TARGET})
endif()

# Set position independent code on all platforms
set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)

# Set static runtime on Windows
if(WIN32)
  if("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "")
    detect_compiler()
    string(TOLOWER "${DETECTED_CMAKE_HOST_SYSTEM_PROCESSOR}" CMAKE_SYSTEM_PROCESSOR_LOWER)
  else()
    string(TOLOWER "${CMAKE_SYSTEM_PROCESSOR}" CMAKE_SYSTEM_PROCESSOR_LOWER)
  endif()

  # set vcpkg triplet to static runtime
  if("${CMAKE_SYSTEM_PROCESSOR_LOWER}" STREQUAL "amd64" OR "${CMAKE_SYSTEM_PROCESSOR_LOWER}" STREQUAL "x64")
    set(VCPKG_TARGET_TRIPLET "x64-windows-static")
  elseif("${CMAKE_SYSTEM_PROCESSOR_LOWER}" STREQUAL "arm64" OR "${CMAKE_SYSTEM_PROCESSOR_LOWER}" STREQUAL "aarch64")
    set(VCPKG_TARGET_TRIPLET "arm64-windows-static")
  elseif("${CMAKE_SYSTEM_PROCESSOR_LOWER}" STREQUAL "x86")
    set(VCPKG_TARGET_TRIPLET "x86-windows-static")
  else()
    message(STATUS "Not setting VCPKG_TARGET_TRIPLET for ${CMAKE_SYSTEM_PROCESSOR}")
  endif()

  # use static runtime library
  set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
endif()

# Defer undefined symbol resolution to runtime on MacOS
if(APPLE)
  set(CMAKE_SHARED_LINKER_FLAGS
    "${CMAKE_SHARED_LINKER_FLAGS} -undefined dynamic_lookup")
endif()

run_vcpkg(VCPKG_URL "https://github.com/microsoft/vcpkg.git" VCPKG_REV
  "608d1dbcd6969679f82b1ca6b89d58939c9b228e")

# Name of the addon
project(addon LANGUAGES C CXX)

project_options(
  ENABLE_CACHE
  ENABLE_COMPILE_COMMANDS_SYMLINK
  ${ENABLE_SANITIZER_UNDEFINED}
)

file(GLOB_RECURSE SOURCES "./src/*.cc")
add_library(addon SHARED ${SOURCES})

if(CMAKE_CXX_COMPILER_ID STREQUAL GNU
  OR CMAKE_CXX_COMPILER_ID STREQUAL Clang
  OR CMAKE_CXX_COMPILER_ID STREQUAL AppleClang)
  target_compile_options(project_warnings INTERFACE "-Wno-shadow")
endif()

target_link_libraries(addon PRIVATE project_options project_warnings)

if(ZMQ_DRAFT)
  target_compile_definitions(addon PRIVATE ZMQ_BUILD_DRAFT_API)
endif()

if(ZMQ_NO_SYNC_RESOLVE)
  target_compile_definitions(addon PRIVATE ZMQ_NO_SYNC_RESOLVE)
endif()

# ZeroMQ
find_package(ZeroMQ CONFIG REQUIRED)
target_link_system_libraries(addon PRIVATE libzmq libzmq-static)

# Node specific
target_include_system_directories(addon PRIVATE ${CMAKE_JS_INC})
target_link_system_libraries(addon PRIVATE ${CMAKE_JS_LIB})

# Node flags
target_compile_definitions(addon PRIVATE V8_COMPRESS_POINTERS)
target_compile_definitions(addon PRIVATE V8_31BIT_SMIS_ON_64BIT_ARCH)
target_compile_definitions(addon PRIVATE V8_REVERSE_JSARGS)
target_compile_definitions(addon PRIVATE BUILDING_NODE_EXTENSION)
target_compile_definitions(addon PRIVATE NAPI_CPP_EXCEPTIONS)

# Windows definitions
if(WIN32)
  target_compile_definitions(addon PRIVATE "NOMINMAX")
  target_compile_definitions(addon PRIVATE "NOGDI")
  target_compile_definitions(addon PRIVATE "WIN32_LEAN_AND_MEAN")
endif()

# Use `.node` for the library without any "lib" prefix
set_target_properties(addon PROPERTIES PREFIX "" SUFFIX ".node")

# Windows delay load node.exe
if(WIN32)
  set_property(TARGET addon PROPERTY LINK_FLAGS "-Xlinker /DELAYLOAD:NODE.EXE")
  target_link_libraries(addon PRIVATE "ShLwApi.lib" "delayimp.lib")
endif()

=== share/one/one-deploy/vendor/ceph-ansible/Makefile ===
# Makefile for constructing RPMs.
# Try "make" (for SRPMS) or "make rpm"

NAME = ceph-ansible

# Set the RPM package NVR from "git describe".
# Examples:
#
#  A "git describe" value of "v2.2.0beta1" would create an NVR
#  "ceph-ansible-2.2.0-0.beta1.1.el8"
#
#  A "git describe" value of "v2.2.0rc1" would create an NVR
#  "ceph-ansible-2.2.0-0.rc1.1.el8"
#
#  A "git describe" value of "v2.2.0rc1-1-gc465f85" would create an NVR
#  "ceph-ansible-2.2.0-0.rc1.1.gc465f85.el8"
#
#  A "git describe" value of "v2.2.0" creates an NVR
#  "ceph-ansible-2.2.0-1.el8"

DIST ?= "el8"
MOCK_CONFIG ?= "centos-stream+epel-8-x86_64"
TAG := $(shell git describe --tags --abbrev=0 --match 'v*')
VERSION := $(shell echo $(TAG) | sed 's/^v//')
COMMIT := $(shell git rev-parse HEAD)
SHORTCOMMIT := $(shell echo $(COMMIT) | cut -c1-7)
RELEASE := $(shell git describe --tags --match 'v*' \
             | sed 's/^v//' \
             | sed 's/^[^-]*-//' \
             | sed 's/-/./')
ifeq ($(VERSION),$(RELEASE))
  RELEASE = 1
endif
ifneq (,$(findstring alpha,$(VERSION)))
    ALPHA := $(shell echo $(VERSION) | sed 's/.*alpha/alpha/')
    RELEASE := 0.$(ALPHA).$(RELEASE)
    VERSION := $(subst $(ALPHA),,$(VERSION))
endif
ifneq (,$(findstring beta,$(VERSION)))
    BETA := $(shell echo $(VERSION) | sed 's/.*beta/beta/')
    RELEASE := 0.$(BETA).$(RELEASE)
    VERSION := $(subst $(BETA),,$(VERSION))
endif
ifneq (,$(findstring rc,$(VERSION)))
    RC := $(shell echo $(VERSION) | sed 's/.*rc/rc/')
    RELEASE := 0.$(RC).$(RELEASE)
    VERSION := $(subst $(RC),,$(VERSION))
endif

ifneq (,$(shell echo $(VERSION) | grep [a-zA-Z]))
    # If we still have alpha characters in our Git tag string, we don't know
    # how to translate that into a sane RPM version/release. Bail out.
    $(error cannot translate Git tag version $(VERSION) to an RPM NVR)
endif

NVR := $(NAME)-$(VERSION)-$(RELEASE).$(DIST)

all: srpm

# Testing only
echo:
	echo COMMIT $(COMMIT)
	echo VERSION $(VERSION)
	echo RELEASE $(RELEASE)
	echo NVR $(NVR)

clean:
	rm -rf dist/
	rm -rf ceph-ansible-$(VERSION)-$(SHORTCOMMIT).tar.gz
	rm -rf $(NVR).src.rpm

dist:
	git archive --format=tar.gz --prefix=ceph-ansible-$(VERSION)/ HEAD > ceph-ansible-$(VERSION)-$(SHORTCOMMIT).tar.gz

spec:
	sed ceph-ansible.spec.in \
	  -e 's/@COMMIT@/$(COMMIT)/' \
	  -e 's/@VERSION@/$(VERSION)/' \
	  -e 's/@RELEASE@/$(RELEASE)/' \
	  > ceph-ansible.spec

srpm: dist spec
	rpmbuild -bs ceph-ansible.spec \
	  --define "_topdir ." \
	  --define "_sourcedir ." \
	  --define "_srcrpmdir ." \
	  --define "dist .$(DIST)"

rpm: dist srpm
	mock -r $(MOCK_CONFIG) rebuild $(NVR).src.rpm \
	  --resultdir=. \
	  --define "dist .$(DIST)"

tag:
	$(eval BRANCH := $(shell git rev-parse --abbrev-ref HEAD))
	$(eval LASTNUM := $(shell echo $(TAG) \
	                    | sed -E "s/.*[^0-9]([0-9]+)$$/\1/"))
	$(eval NEXTNUM=$(shell echo $$(($(LASTNUM)+1))))
	$(eval NEXTTAG=$(shell echo $(TAG) | sed "s/$(LASTNUM)$$/$(NEXTNUM)/"))
	if [[ "$(TAG)" == "$(git describe --tags --match 'v*')" ]]; then \
	    echo "$(SHORTCOMMIT) on $(BRANCH) is already tagged as $(TAG)"; \
	    exit 1; \
	fi
	if [[ "$(BRANCH)" != "master" || "$(BRANCH)" != "main" ]] && \
	   ! [[ "$(BRANCH)" =~ ^stable- ]]; then \
		echo Cannot tag $(BRANCH); \
		exit 1; \
	fi
	@echo Tagging Git branch $(BRANCH)
	git tag $(NEXTTAG)
	@echo run \'git push origin $(NEXTTAG)\' to push to GitHub.

.PHONY: dist rpm srpm tag

=== share/one/one-deploy/vendor/ceph-ansible/requirements.txt ===
# These are Python requirements needed to run ceph-ansible main
ansible-core>=2.15,<2.17,!=2.9.10
netaddr
six

=== src/oca/ruby/opennebula/grpc/Makefile ===
PROTO_DIR = ../../../../rm/grpc/proto
SOURCES   = $(wildcard $(PROTO_DIR)/*.proto)
TS     = .proto_built

.PHONY: all clean

all: $(TS)

$(TS): $(SOURCES)
	grpc_tools_ruby_protoc -I$(PROTO_DIR) --ruby_out=. --grpc_out=. $(PROTO_DIR)/*.proto
	@touch $(TS)

clean:
	rm -f *_pb.rb $(TS)

=== share/one/one-deploy/vendor/ceph-ansible/docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = ceph-ansible
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== share/one/one-deploy/vendor/ceph-ansible/tests/requirements.txt ===
# These are Python requirements needed to run the functional tests
pytest-testinfra
pytest-xdist
pytest
ansible-core>=2.15,<2.17,!=2.9.10
netaddr
mock
jmespath
pytest-rerunfailures
pytest-cov
setuptools

=== share/one/one-deploy/ansible_collections/openstack/config_template/doc/requirements.txt ===
# The order of packages is significant, because pip processes them in the order
# of appearance. Changing the order has an impact on the overall integration
# process, which may cause wedges in the gate later.

# WARNING:
# This file is maintained in the openstack-ansible-tests repository.
# https://opendev.org/openstack/openstack-ansible-tests/src/branch/master/sync/doc/requirements.txt
# If you need to modify this file, update the one in the
# openstack-ansible-tests repository. Once it merges there, the changes will
# automatically be proposed to all the repositories which use it.

sphinx>=2.0.0,!=2.1.0 # BSD
sphinxcontrib-svg2pdfconverter>=0.1.0 # BSD
openstackdocstheme>=2.2.1 # Apache-2.0
reno>=3.1.0 # Apache-2.0
doc8>=0.6.0 # Apache-2.0

=== share/one/gems-dist/gems/grpc-1.78.1/src/ruby/ext/grpc/Makefile ===
hijack: all strip remove_unused_artifacts

hijack_remove_unused_artifacts: all remove_unused_artifacts


SHELL = /bin/sh

# V=0 quiet, V=1 verbose.  other values don't work.
V = 1
V0 = $(V:0=)
Q1 = $(V:1=)
Q = $(Q1:0=@)
ECHO1 = $(V:1=@ :)
ECHO = $(ECHO1:0=@ echo)
NULLCMD = :

#### Start of system configuration section. ####

srcdir = .
topdir = /usr/include
hdrdir = $(topdir)
arch_hdrdir = /usr/include
PATH_SEPARATOR = :
VPATH = $(srcdir):$(arch_hdrdir)/ruby:$(hdrdir)/ruby
prefix = $(DESTDIR)/usr
rubysitearchprefix = $(sitearchlibdir)/$(RUBY_BASE_NAME)
rubyarchprefix = $(DESTDIR)/usr/lib64/ruby
rubylibprefix = $(exec_prefix)/share/ruby
exec_prefix = $(DESTDIR)/usr
vendorarchhdrdir = $(vendorhdrdir)/$(arch)
sitearchhdrdir = $(sitehdrdir)/$(arch)
rubyarchhdrdir = $(DESTDIR)/usr/include
vendorhdrdir = $(rubyhdrdir)/vendor_ruby
sitehdrdir = $(rubyhdrdir)/site_ruby
rubyhdrdir = $(DESTDIR)/usr/include
rubygemsdir = $(DESTDIR)/usr/share/rubygems
vendorarchdir = $(DESTDIR)/usr/lib64/ruby/vendor_ruby
vendorlibdir = $(vendordir)
vendordir = $(DESTDIR)/usr/share/ruby/vendor_ruby
sitearchdir = $(DESTDIR)/usr/local/lib64/ruby/site_ruby
sitelibdir = $(sitedir)
sitedir = $(DESTDIR)/usr/local/share/ruby/site_ruby
rubyarchdir = $(rubyarchprefix)
rubylibdir = $(rubylibprefix)
sitearchincludedir = $(includedir)/$(sitearch)
archincludedir = $(includedir)/$(arch)
sitearchlibdir = $(libdir)/$(sitearch)
archlibdir = $(DESTDIR)/usr/lib64
ridir = $(datarootdir)/$(RI_BASE_NAME)
mandir = $(DESTDIR)/usr/share/man
localedir = $(datarootdir)/locale
libdir = $(exec_prefix)/lib64
psdir = $(docdir)
pdfdir = $(docdir)
dvidir = $(docdir)
htmldir = $(docdir)
infodir = $(DESTDIR)/usr/share/info
docdir = $(datarootdir)/doc/$(PACKAGE)
oldincludedir = $(DESTDIR)/usr/include
includedir = $(exec_prefix)/include
runstatedir = $(DESTDIR)/run
localstatedir = $(DESTDIR)/var
sharedstatedir = $(DESTDIR)/var/lib
sysconfdir = $(DESTDIR)/etc
datadir = $(DESTDIR)/usr/share
datarootdir = $(prefix)/share
libexecdir = $(DESTDIR)/usr/libexec
sbindir = $(DESTDIR)/usr/sbin
bindir = $(exec_prefix)/bin
archdir = $(rubyarchdir)


CC_WRAPPER = 
CC = gcc
CXX = g++
LIBRUBY = $(LIBRUBY_SO)
LIBRUBY_A = lib$(RUBY_SO_NAME)-static.a
LIBRUBYARG_SHARED = -l$(RUBY_SO_NAME)
LIBRUBYARG_STATIC = -l$(RUBY_SO_NAME)-static $(MAINLIBS)
empty =
OUTFLAG = -o $(empty)
COUTFLAG = -o $(empty)
CSRCFLAG = $(empty)

RUBY_EXTCONF_H = 
cflags   = $(hardenflags)  $(optflags) $(debugflags) $(warnflags)
cxxflags = 
optflags = -O3 -fno-fast-math
debugflags = -ggdb3
warnflags = -Wall -Wextra -Wdeprecated-declarations -Wdiv-by-zero -Wduplicated-cond -Wimplicit-function-declaration -Wimplicit-int -Wpointer-arith -Wwrite-strings -Wold-style-definition -Wimplicit-fallthrough=0 -Wmissing-noreturn -Wno-cast-function-type -Wno-constant-logical-operand -Wno-long-long -Wno-missing-field-initializers -Wno-overlength-strings -Wno-packed-bitfield-compat -Wno-parentheses-equality -Wno-self-assign -Wno-tautological-compare -Wno-unused-parameter -Wno-unused-value -Wsuggest-attribute=format -Wsuggest-attribute=noreturn -Wunused-variable -Wmisleading-indentation -Wundef
cppflags = 
CCDLFLAGS = -fPIC
CFLAGS   = $(CCDLFLAGS) -O2 -flto=auto -ffat-lto-objects -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-U_FORTIFY_SOURCE,-D_FORTIFY_SOURCE=3 -Wp,-D_GLIBCXX_ASSERTIONS -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -fstack-protector-strong -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1 -march=x86-64-v3 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -mtls-dialect=gnu2 -fno-omit-frame-pointer -mno-omit-leaf-frame-pointer -fPIC -I/builddir/build/BUILD/opennebula-7.1.80/opennebula-rubygems-7.1.80/gems-dist/gems/grpc-1.78.1/include -g -std=c11  -Wall  -Wextra  -pedantic  $(ARCH_FLAG)
INCFLAGS = -I. -I$(arch_hdrdir) -I$(hdrdir)/ruby/backward -I$(hdrdir) -I$(srcdir)
DEFS     = 
CPPFLAGS =   $(DEFS) $(cppflags)
CXXFLAGS = $(CCDLFLAGS) -O2 -flto=auto -ffat-lto-objects -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-U_FORTIFY_SOURCE,-D_FORTIFY_SOURCE=3 -Wp,-D_GLIBCXX_ASSERTIONS -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -fstack-protector-strong -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1 -march=x86-64-v3 -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection -mtls-dialect=gnu2 -fno-omit-frame-pointer -mno-omit-leaf-frame-pointer  $(ARCH_FLAG)
ldflags  = -L. -Wl,-z,relro -Wl,--as-needed  -Wl,-z,pack-relative-relocs -Wl,-z,now -specs=/usr/lib/rpm/redhat/redhat-hardened-ld -specs=/usr/lib/rpm/redhat/redhat-hardened-ld-errors -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1  -Wl,--build-id=sha1 -fstack-protector-strong -rdynamic -Wl,-export-dynamic -Wl,--no-as-needed -Wl,--version-script="/builddir/build/BUILD/opennebula-7.1.80/opennebula-rubygems-7.1.80/gems-dist/gems/grpc-1.78.1/src/ruby/ext/grpc/ext-export.gcc" /builddir/build/BUILD/opennebula-7.1.80/opennebula-rubygems-7.1.80/gems-dist/gems/grpc-1.78.1/src/ruby/ext/grpc/libs/opt/libgrpc.a -static-libgcc -static-libstdc++
dldflags = -Wl,-z,relro -Wl,--as-needed  -Wl,-z,pack-relative-relocs -Wl,-z,now -specs=/usr/lib/rpm/redhat/redhat-hardened-ld -specs=/usr/lib/rpm/redhat/redhat-hardened-ld-errors -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1  -Wl,--build-id=sha1   
ARCH_FLAG = -m64
DLDFLAGS = $(ldflags) $(dldflags) $(ARCH_FLAG)
LDSHARED = $(CC) -shared
LDSHAREDXX = $(CXX) -shared
AR = gcc-ar
EXEEXT = 

RUBY_INSTALL_NAME = $(RUBY_BASE_NAME)
RUBY_SO_NAME = ruby
RUBYW_INSTALL_NAME = 
RUBY_VERSION_NAME = $(RUBY_BASE_NAME)-$(ruby_version_dir_name)
RUBYW_BASE_NAME = rubyw
RUBY_BASE_NAME = ruby

arch = x86_64-linux
sitearch = $(arch)
ruby_version = 3.3.0
ruby = $(bindir)/$(RUBY_BASE_NAME)
RUBY = $(ruby)
BUILTRUBY = $(bindir)/$(RUBY_BASE_NAME)
ruby_headers = $(hdrdir)/ruby.h $(hdrdir)/ruby/backward.h $(hdrdir)/ruby/ruby.h $(hdrdir)/ruby/defines.h $(hdrdir)/ruby/missing.h $(hdrdir)/ruby/intern.h $(hdrdir)/ruby/st.h $(hdrdir)/ruby/subst.h $(arch_hdrdir)/ruby/config.h

RM = rm -f
RM_RF = rm -fr
RMDIRS = rmdir --ignore-fail-on-non-empty -p
MAKEDIRS = /usr/bin/mkdir -p
INSTALL = /usr/bin/install -c
INSTALL_PROG = $(INSTALL) -m 0755
INSTALL_DATA = $(INSTALL) -m 644
COPY = cp
TOUCH = exit >

#### End of system configuration section. ####

preload = 
libpath = . $(archlibdir)
LIBPATH =  -L. -L$(archlibdir)
DEFFILE = 

CLEANFILES = mkmf.log
DISTCLEANFILES = 
DISTCLEANDIRS = 

extout = 
extout_prefix = 
target_prefix = /grpc
LOCAL_LIBS = 
LIBS = $(LIBRUBYARG_SHARED)  -lm -lpthread  -lc
ORIG_SRCS = rb_byte_buffer.c rb_call.c rb_call_credentials.c rb_channel.c rb_channel_args.c rb_channel_credentials.c rb_completion_queue.c rb_compression_options.c rb_event_thread.c rb_grpc.c rb_grpc_imports.generated.c rb_loader.c rb_server.c rb_server_credentials.c rb_xds_channel_credentials.c rb_xds_server_credentials.c rb_enable_cpp.cc
SRCS = $(ORIG_SRCS) 
OBJS = rb_byte_buffer.o rb_call.o rb_call_credentials.o rb_channel.o rb_channel_args.o rb_channel_credentials.o rb_completion_queue.o rb_compression_options.o rb_event_thread.o rb_grpc.o rb_grpc_imports.generated.o rb_loader.o rb_server.o rb_server_credentials.o rb_xds_channel_credentials.o rb_xds_server_credentials.o rb_enable_cpp.o
HDRS = $(srcdir)/rb_byte_buffer.h $(srcdir)/rb_call.h $(srcdir)/rb_call_credentials.h $(srcdir)/rb_channel.h $(srcdir)/rb_channel_args.h $(srcdir)/rb_channel_credentials.h $(srcdir)/rb_completion_queue.h $(srcdir)/rb_compression_options.h $(srcdir)/rb_event_thread.h $(srcdir)/rb_grpc.h $(srcdir)/rb_grpc_imports.generated.h $(srcdir)/rb_loader.h $(srcdir)/rb_server.h $(srcdir)/rb_server_credentials.h $(srcdir)/rb_xds_channel_credentials.h $(srcdir)/rb_xds_server_credentials.h
LOCAL_HDRS = 
TARGET = grpc_c
TARGET_NAME = grpc_c
TARGET_ENTRY = Init_$(TARGET_NAME)
DLLIB = $(TARGET).so
EXTSTATIC = 
STATIC_LIB = 

TIMESTAMP_DIR = .
BINDIR        = $(bindir)
RUBYCOMMONDIR = $(sitedir)$(target_prefix)
RUBYLIBDIR    = $(sitelibdir)$(target_prefix)
RUBYARCHDIR   = $(sitearchdir)$(target_prefix)
HDRDIR        = $(sitehdrdir)$(target_prefix)
ARCHHDRDIR    = $(sitearchhdrdir)$(target_prefix)
TARGET_SO_DIR =
TARGET_SO     = $(TARGET_SO_DIR)$(DLLIB)
CLEANLIBS     = $(TARGET_SO) false
CLEANOBJS     = $(OBJS) *.bak
TARGET_SO_DIR_TIMESTAMP = $(TIMESTAMP_DIR)/.sitearchdir.-.grpc.time

all:    $(DLLIB)
static: $(STATIC_LIB)
.PHONY: all install static install-so install-rb
.PHONY: clean clean-so clean-static clean-rb

clean-static::
clean-rb-default::
clean-rb::
clean-so::
clean: clean-so clean-static clean-rb-default clean-rb
		-$(Q)$(RM_RF) $(CLEANLIBS) $(CLEANOBJS) $(CLEANFILES) .*.time

distclean-rb-default::
distclean-rb::
distclean-so::
distclean-static::
distclean: clean distclean-so distclean-static distclean-rb-default distclean-rb
		-$(Q)$(RM) Makefile $(RUBY_EXTCONF_H) conftest.* mkmf.log
		-$(Q)$(RM) core ruby$(EXEEXT) *~ $(DISTCLEANFILES)
		-$(Q)$(RMDIRS) $(DISTCLEANDIRS) 2> /dev/null || true

realclean: distclean
install: install-so install-rb

install-so: $(DLLIB) $(TARGET_SO_DIR_TIMESTAMP)
	$(INSTALL_PROG) $(DLLIB) $(RUBYARCHDIR)
clean-static::
	-$(Q)$(RM) $(STATIC_LIB)
install-rb: pre-install-rb do-install-rb install-rb-default
install-rb-default: pre-install-rb-default do-install-rb-default
pre-install-rb: Makefile
pre-install-rb-default: Makefile
do-install-rb:
do-install-rb-default:
pre-install-rb-default:
	@$(NULLCMD)
$(TARGET_SO_DIR_TIMESTAMP):
	$(Q) $(MAKEDIRS) $(@D) $(RUBYARCHDIR)
	$(Q) $(TOUCH) $@

site-install: site-install-so site-install-rb
site-install-so: install-so
site-install-rb: install-rb

.SUFFIXES: .c .m .cc .mm .cxx .cpp .o .S

.cc.o:
	$(ECHO) compiling $(<)
	$(Q) $(CXX) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS) $(COUTFLAG)$@ -c $(CSRCFLAG)$<

.cc.S:
	$(ECHO) translating $(<)
	$(Q) $(CXX) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS) $(COUTFLAG)$@ -S $(CSRCFLAG)$<

.mm.o:
	$(ECHO) compiling $(<)
	$(Q) $(CXX) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS) $(COUTFLAG)$@ -c $(CSRCFLAG)$<

.mm.S:
	$(ECHO) translating $(<)
	$(Q) $(CXX) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS) $(COUTFLAG)$@ -S $(CSRCFLAG)$<

.cxx.o:
	$(ECHO) compiling $(<)
	$(Q) $(CXX) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS) $(COUTFLAG)$@ -c $(CSRCFLAG)$<

.cxx.S:
	$(ECHO) translating $(<)
	$(Q) $(CXX) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS) $(COUTFLAG)$@ -S $(CSRCFLAG)$<

.cpp.o:
	$(ECHO) compiling $(<)
	$(Q) $(CXX) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS) $(COUTFLAG)$@ -c $(CSRCFLAG)$<

.cpp.S:
	$(ECHO) translating $(<)
	$(Q) $(CXX) $(INCFLAGS) $(CPPFLAGS) $(CXXFLAGS) $(COUTFLAG)$@ -S $(CSRCFLAG)$<

.c.o:
	$(ECHO) compiling $(<)
	$(Q) $(CC) $(INCFLAGS) $(CPPFLAGS) $(CFLAGS) $(COUTFLAG)$@ -c $(CSRCFLAG)$<

.c.S:
	$(ECHO) translating $(<)
	$(Q) $(CC) $(INCFLAGS) $(CPPFLAGS) $(CFLAGS) $(COUTFLAG)$@ -S $(CSRCFLAG)$<

.m.o:
	$(ECHO) compiling $(<)
	$(Q) $(CC) $(INCFLAGS) $(CPPFLAGS) $(CFLAGS) $(COUTFLAG)$@ -c $(CSRCFLAG)$<

.m.S:
	$(ECHO) translating $(<)
	$(Q) $(CC) $(INCFLAGS) $(CPPFLAGS) $(CFLAGS) $(COUTFLAG)$@ -S $(CSRCFLAG)$<

$(TARGET_SO): $(OBJS) Makefile
	$(ECHO) linking shared-object grpc/$(DLLIB)
	-$(Q)$(RM) $(@)
	$(Q) $(LDSHAREDXX) -o $@ $(OBJS) $(LIBPATH) $(DLDFLAGS) $(LOCAL_LIBS) $(LIBS)



$(OBJS): $(HDRS) $(ruby_headers)

remove_unused_artifacts: $(DLLIB)
	$(ECHO) Removing unused object artifacts: rm -rf /builddir/build/BUILD/opennebula-7.1.80/opennebula-rubygems-7.1.80/gems-dist/gems/grpc-1.78.1/src/ruby/ext/grpc/objs
	$(Q) rm -rf /builddir/build/BUILD/opennebula-7.1.80/opennebula-rubygems-7.1.80/gems-dist/gems/grpc-1.78.1/src/ruby/ext/grpc/objs
	$(ECHO) Removing unused grpc core libraries: rm -f /builddir/build/BUILD/opennebula-7.1.80/opennebula-rubygems-7.1.80/gems-dist/gems/grpc-1.78.1/src/ruby/ext/grpc/libs/opt/*.a
	$(Q) rm -f /builddir/build/BUILD/opennebula-7.1.80/opennebula-rubygems-7.1.80/gems-dist/gems/grpc-1.78.1/src/ruby/ext/grpc/libs/opt/*.a

strip: $(DLLIB)
	$(ECHO) Stripping $(DLLIB)
	$(Q) strip -S -x $(DLLIB)

=== changelog ===
opennebula (7.1.80-1) unstable; urgency=low

  * Build for 7.1.80-1 (Git revision 838542b3)

 -- OpenNebula Team <contact@opennebula.io>  Wed, 25 Feb 2026 11:09:08 +0000

=== control ===
# https://stackoverflow.com/questions/32590638/check-multiple-conditions-at-once-using-m4-preprocessor





Source: opennebula
Section: utils
Priority: extra
Maintainer: OpenNebula Team <contact@opennebula.io>
Build-Depends: bash-completion,
               bison,
               debhelper (>= 7.0.50~),
               default-jdk,
               flex,
               javahelper (>= 0.32),
               default-libmysqlclient-dev,
               libsqlite3-dev,
               libssl-dev,
               libws-commons-util-java,
               libxml2-dev,
               libxmlrpc-c++8-dev,
               libxslt1-dev,
               libsystemd-dev,
               libvncserver-dev,
               ruby,
               python3-setuptools,
               scons,
# Rubygems, TODO: reduce
               ruby-dev,
               make,
               gcc,
               libsqlite3-dev,
               libcurl4-openssl-dev,
               rake,
               libxml2-dev,
               libxslt1-dev,
               patch,
               g++,
               build-essential,
               libssl-dev,
               libaugeas-dev,
               nodejs (>= 20), nodejs (< 21),
               npm,
               libzmq5,
               libzmq3-dev,
               make,
               g++,
               python3,
               unzip,
               libtool,
               autoconf,
               libcairo2-dev,
               libossp-uuid-dev,
               freerdp2-dev,
               libssh2-1-dev,
               libpango1.0-dev,
               libpulse-dev,
               libwebp-dev,
               libvorbis-dev,
               default-libmysqlclient-dev | libmysqlclient-dev,
               libabsl-dev,
               libgrpc++-dev,
               protobuf-compiler-grpc,
               protoc-gen-go,
               pkg-config
Standards-Version: 3.9.3
Homepage: http://opennebula.org/
Vcs-Git: git://git.debian.org/pkg-opennebula/opennebula.git
Vcs-Browser: http://git.debian.org/?p=pkg-opennebula/opennebula.git

Package: opennebula
Architecture: any
Pre-Depends: opennebula-common-onecfg (= ${source:Version})
Depends: apg,
         xorriso,
         opennebula-common (= ${source:Version}),
         opennebula-tools (= ${source:Version}),
         opennebula-libs (= ${source:Version}),
         opennebula-migration (= ${source:Version}),
         opennebula-rubygems (= ${source:Version}),         libxmlrpc-c++8v5,
         wget,
         curl,
         rsync,
         tar,
         sqlite3,
         qemu-utils,
         iputils-arping,
         file,
         procps,
         sudo,
         uuid-runtime,
         libaugeas0,
         diffutils,
         git,
         patch,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: ruby-opennebula (<< 5.5.80),
          opennebula-flow (<< 5.0.2),
          opennebula-gate (<< 5.0.2),
          opennebula-common (<< 5.5.80),
          opennebula-addon-markets (<< 5.10.2),
          opennebula-provision (<< 7.0.0),
          opennebula-provision-data (<< 7.0.0),
          onescape (<< 5.13.80)
Breaks:  ruby-opennebula (<< 5.5.80),
         opennebula-flow (<< 5.0.2),
         opennebula-gate (<< 5.0.2),
         opennebula-common (<< 5.5.80),
         opennebula-addon-markets (<< 5.10.2),
         opennebula-provision (<< 7.0.0),
         opennebula-provision-data (<< 7.0.0),
         onescape (<< 5.13.80)
Suggests: mysql-server
Description: OpenNebula Server and Scheduler (Community Edition)

Package: opennebula-dbgsym
Architecture: any
Depends: opennebula (= ${source:Version}),
         ${misc:Depends}
Description: Debug symbols for package opennebula (Community Edition)


Package: opennebula-fireedge
Architecture: any
Pre-Depends: opennebula-common-onecfg (= ${source:Version})
Depends: opennebula-common (= ${source:Version}),
         nodejs (>= 20), nodejs (< 21),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: opennebula-guacd (= ${source:Version})
Conflicts: opennebula (<< ${source:Version})
Description: OpenNebula web interface FireEdge (Community Edition)
 Browser based UI for OpenNebula application management.


Package: opennebula-gate
Architecture: all
Pre-Depends: opennebula-common-onecfg (= ${source:Version})
Depends: opennebula-common (= ${source:Version}),
         opennebula-libs (= ${source:Version}),
         opennebula-rubygems (= ${source:Version}),         ${misc:Depends}
Conflicts: opennebula (<< ${source:Version})
Description: OpenNebula Gate server (Community Edition)
 Server for information exchange between Virtual Machines and OpenNebula.

Package: opennebula-flow
Architecture: all
Pre-Depends: opennebula-common-onecfg (= ${source:Version})
Depends: opennebula-common (= ${source:Version}),
         opennebula-libs (= ${source:Version}),
         opennebula-rubygems (= ${source:Version}),         curl,
         ${misc:Depends}
Conflicts: opennebula (<< ${source:Version})
Description:  OpenNebula Flow server (Community Edition)
 Server for multi-VM orchestration.

Package: opennebula-common
Architecture: all
Pre-Depends: opennebula-common-onecfg (= ${source:Version})
Depends: adduser,
         openssh-client,
         jq,
         ${misc:Depends}
Recommends: lvm2, sudo (>= 1.7.2p1)
Replaces: opennebula (<< 5.11.90),
          opennebula-node (<< 5.11.90),
          opennebula-node-firecracker (<< 5.11.90)
Breaks: opennebula (<< 5.11.90),
        opennebula-node (<< 5.11.90),
        opennebula-node-firecracker (<< 5.11.90)
Description: Common OpenNebula package shared by various components (Community Edition)

Package: opennebula-common-onecfg
Architecture: all
Depends: ${misc:Depends}
Description: Helpers for OpenNebula onecfg (Community Edition)
Conflicts: opennebula-common-onescape

Package: opennebula-node-kvm
Architecture: all
Depends: adduser,
         libvirt-daemon-system,
         qemu-kvm | pve-qemu-kvm | qemu-system,
         qemu-utils,
         opennebula-common (= ${source:Version}),
         opennebula-rubygems (= ${source:Version}),         ruby,
         vlan,
         ipset,
         pciutils,
         rsync,
         tar,
         cron,
         augeas-tools,
         qemu-block-extra,
         libxml2-utils,
         iptables,
         nftables,
         libnbd-bin,
         nfs-common,
         python3-numpy,
         python3-scipy,
         dmidecode,
         swtpm-tools,
         ${misc:Depends}
Breaks: opennebula-node (<< 5.13.80)
Replaces: opennebula-node (<< 5.13.80)
Recommends: openssh-server | ssh-server
Provides: opennebula-node
Conflicts: opennebula-node-lxc,
           opennebula-node-lxd,
           opennebula-node-firecracker
Description: Services for OpenNebula KVM node (Community Edition)

Package: opennebula-node-lxc
Architecture: any
Depends: adduser,
         opennebula-common (= ${source:Version}),
         opennebula-rubygems (= ${source:Version}),         ruby,
         vlan,
         ipset,
         pciutils,
         rsync,
         tar,
         cron,
         augeas-tools,
         libarchive-tools,
         libvncserver1,
         qemu-utils,
         bindfs,
         lxc,
         libxml2-utils,
         xfsprogs,
         e2fsprogs,
         passwd,
         iptables,
         nftables,
         nfs-common,
         python3-numpy,
         ${misc:Depends}
Suggests: rbd-nbd
Conflicts: opennebula-node-lxd,
           opennebula-node-kvm,
           opennebula-node-firecracker
Description: Services for OpenNebula LXC node (Community Edition)

Package: python3-pyone
Section: python
Architecture: all
Depends: python3,
         python3-dict2xml,
         python3-lxml,
         python3-requests,
         python3-six,
         python3-tblib,
         python3-xmltodict,
         ${misc:Depends},
         ${python:Depends}
Description: Python 3 bindings for OpenNebula Cloud API, OCA (Community Edition)

Package: opennebula-libs
Architecture: all
Depends: ruby,
         libzmq5,
# Devel package brings libzmq.so symlink required by ffi-rzmq-core gem
         libzmq3-dev,
         opennebula-rubygems (= ${source:Version}),         ${misc:Depends},
         ${ruby:Depends}
Breaks: opennebula-gate (<< 4.90.5),
        opennebula-tools (<< 5.13.80),
        ruby-opennebula (<< 5.13.80),
        opennebula (<< 5.13.80)
Replaces: opennebula-gate (<< 4.90.5),
          opennebula-tools (<< 5.13.80),
          ruby-opennebula (<< 5.13.80),
          opennebula (<< 5.13.80)
Description: OpenNebula libraries (Community Edition)


Package: opennebula-rubygems
Architecture: any
Depends: ruby,
         ${misc:depends},
         ${shlibs:Depends}
Conflicts: opennebula (<< ${source:Version}),
           opennebula-rubygem-activesupport,
           opennebula-rubygem-addressable,
           opennebula-rubygem-amazon-ec2,
           opennebula-rubygem-augeas,
           opennebula-rubygem-aws-eventstream,
           opennebula-rubygem-aws-sdk,
           opennebula-rubygem-aws-sdk-core,
           opennebula-rubygem-aws-sdk-resources,
           opennebula-rubygem-aws-sigv4,
           opennebula-rubygem-azure,
           opennebula-rubygem-azure-core,
           opennebula-rubygem-builder,
           opennebula-rubygem-chunky-png,
           opennebula-rubygem-concurrent-ruby,
           opennebula-rubygem-configparser,
           opennebula-rubygem-curb,
           opennebula-rubygem-daemons,
           opennebula-rubygem-dalli,
           opennebula-rubygem-eventmachine,
           opennebula-rubygem-faraday,
           opennebula-rubygem-faraday-middleware,
           opennebula-rubygem-ffi,
           opennebula-rubygem-ffi-rzmq,
           opennebula-rubygem-ffi-rzmq-core,
           opennebula-rubygem-hashie,
           opennebula-rubygem-highline,
           opennebula-rubygem-i18n,
           opennebula-rubygem-inflection,
           opennebula-rubygem-ipaddress,
           opennebula-rubygem-jmespath,
           opennebula-rubygem-memcache-client,
           opennebula-rubygem-mime-types,
           opennebula-rubygem-mime-types-data,
           opennebula-rubygem-mini-portile2,
           opennebula-rubygem-minitest,
           opennebula-rubygem-multipart-post,
           opennebula-rubygem-mustermann,
           opennebula-rubygem-mysql2,
           opennebula-rubygem-net-ldap,
           opennebula-rubygem-nokogiri,
           opennebula-rubygem-ox,
           opennebula-rubygem-parse-cron,
           opennebula-rubygem-polyglot,
           opennebula-rubygem-public-suffix,
           opennebula-rubygem-rack,
           opennebula-rubygem-rack-protection,
           opennebula-rubygem-rotp,
           opennebula-rubygem-rqrcode,
           opennebula-rubygem-rqrcode-core,
           opennebula-rubygem-scrub-rb,
           opennebula-rubygem-sequel,
           opennebula-rubygem-sinatra,
           opennebula-rubygem-sqlite3,
           opennebula-rubygem-systemu,
           opennebula-rubygem-thin,
           opennebula-rubygem-thor,
           opennebula-rubygem-thread-safe,
           opennebula-rubygem-tilt,
           opennebula-rubygem-treetop,
           opennebula-rubygem-trollop,
           opennebula-rubygem-tzinfo,
           opennebula-rubygem-uuidtools,
           opennebula-rubygem-xmlrpc,
           opennebula-rubygem-xml-simple,
           opennebula-rubygem-zendesk-api
Description: Ruby dependencies for OpenNebula (Community Edition)


Package: opennebula-tools
Architecture: all
Pre-Depends: opennebula-common-onecfg (= ${source:Version})
Depends: opennebula-common (= ${source:Version}),
         opennebula-libs (= ${source:Version}),
         opennebula-rubygems (= ${source:Version}),         util-linux,
         ${misc:Depends},
         ${ruby:Depends}
Recommends: bash-completion
Suggests: gnuplot-nox
Breaks: opennebula (<< 5.5.90),
        opennebula-addon-tools (<< 5.10.2)
Replaces: opennebula (<< 5.5.90),
          opennebula-addon-tools (<< 5.10.2)
Description: OpenNebula command line tools (Community Edition)

Package: libopennebula-java

=== rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# Handle group assignment: libvirt (Debian) and libvirtd (Ubuntu)
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	LIB_VIRT_GROUP = libvirtd
else
	LIB_VIRT_GROUP = libvirt
endif

# Build arguments
ifneq (,$(filter opennebula-ovirtapi, $(shell dh_listpackages)))
	ARGS_ENTERPRISE = yes
else
	ARGS_ENTERPRISE = no
endif

ifneq (,$(filter opennebula-fireedge, $(shell dh_listpackages)))
	ARGS_FIREEDGE = yes
else
	ARGS_FIREEDGE = no
endif

# distribution specific content
DIR_SUDOERS  = 'debian'
DIR_SERVICES = 'systemd'
DIR_TMPFILES = ''
GEMFILE_LOCK = 'Debian13'

# https://wiki.debian.org/HardeningWalkthrough#Selecting_security_hardening_options
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

dpkg_buildflags = DEB_LDFLAGS_MAINT_APPEND="-Wl,--as-needed" dpkg-buildflags

# injecting CPPFLAGS to CFLAGS and CXXFLAGS
export CPPFLAGS:=$(shell $(dpkg_buildflags) --get CPPFLAGS)
export CFLAGS:=$(shell $(dpkg_buildflags) --get CFLAGS) $(CPPFLAGS)
export CXXFLAGS:=$(shell $(dpkg_buildflags) --get CXXFLAGS) $(CPPFLAGS)
export LDFLAGS:=$(shell $(dpkg_buildflags) --get LDFLAGS)
export MAKEFLAGS:=-j

%:
	dh $@ --with javahelper,bash-completion,systemd

override_dh_auto_build:
	tar xzvf build_opennebula.tar.gz

	# we take only prebuilt Java OCA + deps
	tar xzvf java-oca-*.tar.gz
	mv java-oca-*/jar/ src/oca/java/

	tar xzvf vendor.tar.gz
	for Z in *.zip; do unzip $Z; done
	mv xmlrpc-client-*.jar xmlrpc-common-*.jar ws-commons-util-*.jar src/oca/java/jar/

	tar xzvf one-deploy.tar.gz

ifneq (,$(filter opennebula-ovirtapi, $(shell dh_listpackages)))
	tar xzvf opennebula-ee-tools-*.tar.gz
endif
ifneq (,$(filter opennebula-rubygems, $(shell dh_listpackages)))
	tar xzvf opennebula-rubygems-*.tar.gz

	cd opennebula-rubygems-* && \
		NOKOGIRI_USE_SYSTEM_LIBRARIES=yes \
		CPATH=/usr/include/libxml2 \
		GEM_PATH=$$PWD/gems-dist/ \
		GEM_HOME=$$PWD/gems-dist/ \
			gem install \
				--local \
				--ignore-dependencies \
				--no-document \
				--conservative \
				--install-dir $$PWD/gems-dist \
				--bindir $$PWD/gems-dist/bin/ \
				$$(cat manifest)

	# drop build artifacts
	rm -rf opennebula-rubygems-*/gems-dist/cache \
		opennebula-rubygems-*/gems-dist/gems/*/ext
endif
ifneq (,$(filter opennebula-guacd, $(shell dh_listpackages)))
	rm guacamole-server-1.4.0.zip
	unzip guacamole-server-*.zip

	cd guacamole-server-* && \
		autoreconf -i && \
		CFLAGS=-Wno-error ./configure \
			--prefix=/usr/share/one/guacd \
			--exec-prefix=/usr/share/one/guacd \
			--with-freerdp-plugin-dir=/usr/share/one/guacd \
			--disable-static \
			--without-pulse && \
		make
endif

ifneq (,$(filter opennebula-fireedge, $(shell dh_listpackages)))
	# build doesn't have set HOME, also we can't write into /etc
	echo 'cache=/tmp'        >> src/fireedge/.npmrc
	echo 'offline=true'      >> src/fireedge/.npmrc
	echo 'zmq_external=true' >> src/fireedge/.npmrc

	mkdir opennebula-fireedge-modules
	tar -xzvf opennebula-fireedge-modules*.tar.gz \
		-C opennebula-fireedge-modules/ \
		--strip-components=1

	# backup original package-lock.json and update dependencies locations
	# from remote https:// to local predownloaded files
	cd src/fireedge && \
		cp package-lock.json package-lock.json.bak && \
		sed -i -e 's/\(resolved": "\)https*:\/\//\1file:..\/..\/opennebula-fireedge-modules\//' package-lock.json
endif

	#XMLRPC_DIR="debian/" debian/build_opennebula.sh
	./build_opennebula.sh \
			systemd=yes \
			gitversion="$(shell cat debian/gitversion)" \
			enterprise="${ARGS_ENTERPRISE}" \
			fireedge="${ARGS_FIREEDGE}"

ifneq (,$(filter opennebula-fireedge, $(shell dh_listpackages)))
	mv -f src/fireedge/package-lock.json.bak src/fireedge/package-lock.json
	unlink src/fireedge/.npmrc
endif

override_dh_auto_install:
ifeq ($(DEB_TARGET_ARCH),amd64)
	DESTDIR=dist ./install.sh
else
ifeq ($(DEB_TARGET_ARCH),arm64)
	DESTDIR=dist ./install.sh -a arm64
else
	echo "ERROR: Unsupported architecture '$(DEB_TARGET_ARCH)'" >&2
	exit 1
endif
endif

# install one-deploy
	mkdir -p dist/usr/share/one/one-deploy
	cp -a one-deploy/* dist/usr/share/one/one-deploy/

ifneq (,$(filter opennebula-ovirtapi, $(shell dh_listpackages)))
	(cd one-ee-tools && \
	DESTDIR=../dist ./install-ee-tools.sh -a /etc/apache2/sites-available -s /etc/systemd/system/apache2.service.d)
	dh_install -p opennebula one-ee-tools/src/onegather/* /usr/bin
	dh_install -p opennebula one-ee-tools/src/onefabric/front-end/onefabric /usr/bin
	dh_install -p opennebula one-ee-tools/src/onefabric/front-end/onefabric_helper.rb /usr/lib/one/ruby/cli/one_helper
endif
ifneq (,$(filter opennebula-guacd, $(shell dh_listpackages)))
	cd guacamole-server-* && \
		make install DESTDIR=$(shell readlink -f dist)

	rm -rf dist/usr/share/one/guacd/include

	dh_install -p opennebula-guacd share/pkgs/services/${DIR_SERVICES}/opennebula-guacd.service \
		/lib/systemd/system/
endif
ifneq (,$(filter opennebula-rubygems, $(shell dh_listpackages)))
	cp -a opennebula-rubygems-*/gems-dist dist/usr/share/one/
endif
ifneq (,$(filter opennebula-ovirtapi, $(shell dh_listpackages)))
	echo EE > dist/var/lib/one/remotes/EDITION
else
	echo CE > dist/var/lib/one/remotes/EDITION
endif
	dh_auto_install
ifneq (,$(filter opennebula-common, $(shell dh_listpackages)))
	dh_install -p opennebula-common share/pkgs/sudoers/${DIR_SUDOERS}/opennebula \
		/etc/sudoers.d
	dh_install -p opennebula-common share/pkgs/tmpfiles/${DIR_TMPFILES}/opennebula-common.conf \
		/usr/lib/tmpfiles.d/
	dh_install -p opennebula-common share/pkgs/tmpfiles/${DIR_TMPFILES}/opennebula-node.conf \
		/usr/lib/tmpfiles.d/
endif
ifneq (,$(filter opennebula, $(shell dh_listpackages)))
	dh_install -p opennebula share/pkgs/logrotate/opennebula /etc/logrotate.d/
	dh_install -p opennebula share/pkgs/logrotate/opennebula-hem /etc/logrotate.d/

	dh_install -p opennebula share/pkgs/services/${DIR_SERVICES}/opennebula.service \
		/lib/systemd/system/
	dh_install -p opennebula share/pkgs/services/${DIR_SERVICES}/opennebula-ssh-agent.service \
		/lib/systemd/system/
	dh_install -p opennebula share/pkgs/services/${DIR_SERVICES}/opennebula-ssh-socks-cleaner.service \
		/lib/systemd/system/
	dh_install -p opennebula share/pkgs/services/${DIR_SERVICES}/opennebula-ssh-socks-cleaner.timer \
		/lib/systemd/system/
	dh_install -p opennebula share/pkgs/services/${DIR_SERVICES}/opennebula-showback.service \
		/lib/systemd/system/
	dh_install -p opennebula share/pkgs/services/${DIR_SERVICES}/opennebula-showback.timer \
		/lib/systemd/system/
	dh_install -p opennebula share/pkgs/services/${DIR_SERVICES}/opennebula-hem.service \
		/lib/systemd/system/
	dh_install -p opennebula share/augeas/oned.aug /usr/share/augeas/lenses/
	dh_install -p opennebula share/pkgs/sudoers/opennebula-server /etc/sudoers.d/
endif
ifneq (,$(filter opennebula-fireedge, $(shell dh_listpackages)))
	dh_install -p opennebula-fireedge share/pkgs/logrotate/opennebula-fireedge /etc/logrotate.d/

	dh_install -p opennebula-fireedge share/pkgs/services/${DIR_SERVICES}/opennebula-fireedge.service \
		/lib/systemd/system/
endif
ifneq (,$(filter opennebula-gate, $(shell dh_listpackages)))
	dh_install -p opennebula-gate share/pkgs/logrotate/opennebula-gate /etc/logrotate.d/

	dh_install -p opennebula-gate share/pkgs/services/${DIR_SERVICES}/opennebula-gate.service \
		/lib/systemd/system/
endif
ifneq (,$(filter opennebula-flow, $(shell dh_listpackages)))
	dh_install -p opennebula-flow share/pkgs/logrotate/opennebula-flow /etc/logrotate.d/

	dh_install -p opennebula-flow share/pkgs/services/${DIR_SERVICES}/opennebula-flow.service \
		/lib/systemd/system/
endif
ifneq (,$(filter opennebula-form, $(shell dh_listpackages)))
	dh_install -p opennebula-form share/pkgs/services/${DIR_SERVICES}/opennebula-form.service \
		/lib/systemd/system/
endif
ifneq (,$(filter opennebula-prometheus, $(shell dh_listpackages)))
	dh_install -p opennebula-prometheus src/oneprometheus/alertmanager/systemd/opennebula-alertmanager.service \
		/lib/systemd/system/
